<?php

namespace LaraBB\User\UI\Web\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\RedirectResponse;

/**
 * Class Destroy
 * @package LaraBB\User\UI\Web\Requests
 */
class Destroy extends FormRequest
{
    /**
     * @return bool
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * @return string[]
     */
    public function rules(): array
    {
        return [
            'uuid' => 'required|uuid|exists:users,uuid',
        ];
    }

    /**
     * @return array|string[]
     */
    public function messages(): array
    {
        return [
            'uuid.required' => 'Es wurde keine UUID übergeben.',
            'uuid.uuid'     => 'Die übergebene UUID ist ungültig.',
            'uuid.exists'   => 'Der zu löschende Benutzer existiert nicht.',
        ];
    }

    /**
     * @return RedirectResponse
     */
    public function success(): RedirectResponse
    {
        return redirect()->route('admin.users')->with([
            'success'       => 'Der Benutzer wurde erfolgreich gelöscht.',
            'alert-options' => 'aside'
        ]);
    }

    /**
     * @return RedirectResponse
     */
    public function failed(): RedirectResponse
    {
        return redirect()->route('admin.users')->with([
            'error' => 'Der Benutzer konnte aufgrund einer technichen Störung nicht gelöscht werden.'
        ]);
    }
}
